using System;
using System.Text;
using FCSColl = FCSlib.Data.Collections;

namespace LoggerDemo {
  public class Logger<T> {
    private readonly FCSColl::List<string> outputLines;

    private readonly T val;
    public T Value { get { return val; } }

    public Logger(T val, FCSColl::List<string> outputLines) {
      this.val = val;
      this.outputLines = outputLines;
    }

    public Logger(T val, string message) : this(val, new FCSColl::List<string>(message)) { }
    public Logger(T val) : this(val, FCSColl::List<string>.Empty) { }

    public string LogOutput( ) {
      var builder = new StringBuilder( );
      foreach (string outputLine in outputLines)
        builder.AppendLine(outputLine);
      return builder.ToString( );
    }

    public Logger<R> Bind<R>(Func<T, Logger<R>> g) {
      var r = g(val);
      return new Logger<R>(r.Value, 
        outputLines.Append(r.outputLines));
    }
  }

}
