using System;

namespace ThirdLeftChild {
  public class Maybe<T> {
    public static readonly Maybe<T> Empty = new Maybe<T>( );
    private readonly T val;
    public T Value { get { return val; } }
    private readonly bool isEmpty;
    public bool IsEmpty { get { return isEmpty; } }
    public bool HasValue { get { return !isEmpty; } }

    public Maybe(T val) {
      this.val = val;
    }

    private Maybe( ) {
      this.isEmpty = true;
    }

    public Maybe<R> Bind<R>(Func<T, Maybe<R>> g) {
      return IsEmpty ? Maybe<R>.Empty : g(Value);
    }

    public static Maybe<T> 
    operator &(Maybe<T> x, Func<T, Maybe<T>> g) => x.Bind(g);


    // This overload is an idea to shift the call to NotNullMaybe
    // into this class - but it doesn't really work under the
    // circumstances because ToNotNullMaybe has a constraint of 
    // "T: class" on it, so we'd have to be much more restrictive
    // with the entire Maybe<T> to make this work.

    //    public static Maybe<T> operator &(Maybe<T> x, Func<T, T> g) {
    //      Func<T, Maybe<T>> f = t => g(t).ToNotNullMaybe();
    //      return x.Bind(f);
    //    }

  }

}
